@echo off
setlocal enabledelayedexpansion

TITLE FO4 Hotkeys Installer
echo ---- FO4 Hotkeys Installer by registrator2000 ----
echo.

REM Find the user's My Documents directory. Directory is named differently for different system languages.
for /f "usebackq tokens=3*" %%a ^
in (`reg query "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" /v "Personal"`) ^
do (
    if [%%b] == [] (
        set mydocuments=%%a
    ) else (
        set mydocuments=%%a %%b
    )
)

REM Find the Fallout 4 installation directory.
for /f "usebackq tokens=4*" %%a ^
in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\Bethesda Softworks\Fallout4" /v "Installed Path"`) ^
do (set fallout4dir=%%a %%b)

echo Fallout 4 Installation Directory: %fallout4dir%
echo.

if not exist "%fallout4dir%\Fallout4.exe" (
    echo ERROR - Could not find Fallout4.exe.
    echo Check if the installation directory is correct.
    echo.
    goto FAIL
)

REM Set the ini.
set "file=%mydocuments%\My Games\Fallout4\Fallout4Custom.ini"

echo Updating INI at %file%...
echo.

set c=Y
set /P c=Continue? [Enter/Y/N] 
echo.
if /I "%c%" NEQ "Y" (
    goto CANCEL
)

REM pause

if exist "%file%" (
    findstr /v /i "bUseConsoleHotkeys= sConsoleINI=" "%file%" >"%file%.tmp"

    set area=[Menu]
    set key=bUseConsoleHotkeys
    set currarea=
    for /f "usebackq delims=" %%a in ("%file%.tmp") do (
        set ln=%%a
        >>"%file%.tmp2" echo !ln!
        
        if "x!ln:~0,1!"=="x[" (
            set currarea=!ln!
            if "x!area!"=="x!currarea!" (
                >>"%file%.tmp2" echo/bUseConsoleHotkeys=1
                >>"%file%.tmp2" echo/sConsoleINI=Data\Hotkeys.ini
                set foundHeader=1
                echo Existing section header found. Adding to section...
                echo.
            )
        ) else (
            for /f "tokens=1,2 delims==" %%b in ("!ln!") do (
                set currkey=%%b
                set currval=%%c
            )
        )
    )
    
    if not defined foundHeader (
        >>"%file%.tmp2" echo/[Menu]
        >>"%file%.tmp2" echo/bUseConsoleHotkeys=1
        >>"%file%.tmp2" echo/sConsoleINI=Data\Hotkeys.ini
        echo Section header not found. Section created.
        echo.
    )
    
    move /y "%file%.tmp2" "%file%" >nul
    del "%file%.tmp"
    
    echo Copying files...
    xcopy "Hotkeys.ini" "%fallout4dir%\Data\" /Q
    
    echo.
    echo Hotkeys successfully enabled.
    echo.
    
) else (
    echo Fallout4Custom.ini couldn't be found. Install failed.
    echo.
)

:SUCCESS
pause
goto:EOF

:CANCEL
echo Installation cancelled.
echo.
pause
goto:EOF

:FAIL
echo Installation failed.
echo.
pause